Index: branches/0.3-poznan-univ/source/App/TAppRenderer/TAppRendererCfg.cpp
===================================================================
--- branches/0.3-poznan-univ/source/App/TAppRenderer/TAppRendererCfg.cpp	(revision 41)
+++ branches/0.3-poznan-univ/source/App/TAppRenderer/TAppRendererCfg.cpp	(revision 45)
@@ -183,4 +183,10 @@
   m_bUseSetupString = ( m_pchViewConfig != NULL ) && ( m_iRenderMode != 0);
 
+#if POZNAN_NONLINEAR_DEPTH      
+  TComNonlinearDepthModel cNonlinearDepthModel;
+  cNonlinearDepthModel.Clear();
+  cNonlinearDepthModel.Init();
+#endif
+
   if ( m_iRenderMode == 10 )
   {
@@ -188,5 +194,5 @@
       m_pchCameraParameterFile, m_pchBaseViewCameraNumbers, NULL, NULL, m_iLog2SamplingFactor+m_iShiftPrecision
 #if POZNAN_NONLINEAR_DEPTH      
-      ,1.0f 
+      ,&cNonlinearDepthModel 
 #endif
       );
@@ -211,5 +217,5 @@
       m_pchCameraParameterFile, m_pchBaseViewCameraNumbers, NULL, piaTempViews, m_iLog2SamplingFactor+m_iShiftPrecision
 #if POZNAN_NONLINEAR_DEPTH
-      , 1.0f 
+      , &cNonlinearDepthModel 
 #endif
       );
@@ -220,5 +226,5 @@
       m_pchCameraParameterFile, m_pchBaseViewCameraNumbers, m_pchSynthViewCameraNumbers, NULL, m_iLog2SamplingFactor+m_iShiftPrecision
 #if POZNAN_NONLINEAR_DEPTH
-      ,1.0f 
+      ,&cNonlinearDepthModel 
 #endif
       );
@@ -292,5 +298,9 @@
 
   xConfirmPara( m_iPreFilterSize      < 0 || m_iPreFilterSize      >  3, "PreFilterSize      must be more than or equal to 0 and less than 4" );
+#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU 
+  xConfirmPara( m_iBlendMode          < 0 || m_iBlendMode          >  4, "BlendMode          must be more than or equal to 0 and less than 5"  );
+#else
   xConfirmPara( m_iBlendMode          < 0 || m_iBlendMode          >  3, "BlendMode          must be more than or equal to 0 and less than 4"  );
+#endif
   xConfirmPara( m_iBlendZThresPerc    < 0 || m_iBlendZThresPerc    > 100,"BlendZThresPerc    must be more than or equal to 0 and less than 101"  );
   xConfirmPara( m_iBlendHoleMargin    < 0 || m_iBlendHoleMargin    >  20,"BlendHoleMargin    must be more than or equal to 0 and less than 19"  );
Index: branches/0.3-poznan-univ/source/App/TAppRenderer/TAppRendererTop.cpp
===================================================================
--- branches/0.3-poznan-univ/source/App/TAppRenderer/TAppRendererTop.cpp	(revision 41)
+++ branches/0.3-poznan-univ/source/App/TAppRenderer/TAppRendererTop.cpp	(revision 45)
@@ -288,4 +288,5 @@
                 iLeftBaseViewIdx  = 0;
                 iRightBaseViewIdx = iFillViewIdx;
+                
               }
               else
@@ -298,4 +299,36 @@
             }
           }
+#if POZNAN_ENCODE_ONLY_DISOCCLUDED_CU 
+          else if ( m_iBlendMode == 4 )
+          {
+            if ( bIsBaseView && (iLeftBaseViewIdx == 0) )
+            {
+              bRender = false;
+            }
+            else
+            {
+              Int iDistLeft  = abs( m_cCameraData.getBaseId2SortedId()[0] - m_cCameraData.getBaseId2SortedId() [iLeftBaseViewIdx ]  );
+              Int iDistRight = abs( m_cCameraData.getBaseId2SortedId()[0] - m_cCameraData.getBaseId2SortedId() [iRightBaseViewIdx]  );
+
+              Int iFillViewIdx = (0!=iLeftBaseViewIdx)? iLeftBaseViewIdx: iRightBaseViewIdx;
+
+              if( m_cCameraData.getBaseId2SortedId()[0] < m_cCameraData.getBaseId2SortedId() [iFillViewIdx] )
+              {
+                iBlendMode        = 0;
+                iLeftBaseViewIdx  = 0;
+                iRightBaseViewIdx = iFillViewIdx;
+                std::cout << "iBlen: " << iBlendMode << "iLeft: " << iLeftBaseViewIdx << "iRight: " << iRightBaseViewIdx <<std::endl;
+              }
+              else
+              {
+                iBlendMode        = 0;
+                iLeftBaseViewIdx  = iFillViewIdx;
+                iRightBaseViewIdx = 0;
+                std::cout << "iBlen: " << iBlendMode << "iLeft: " << iLeftBaseViewIdx << "iRight: " << iRightBaseViewIdx <<std::endl;
+              }
+
+            }
+          }
+#endif
           else
           {
Index: branches/0.3-poznan-univ/source/Lib/TLibCommon/TComMP.cpp
===================================================================
--- branches/0.3-poznan-univ/source/Lib/TLibCommon/TComMP.cpp	(revision 41)
+++ branches/0.3-poznan-univ/source/Lib/TLibCommon/TComMP.cpp	(revision 45)
@@ -934,5 +934,5 @@
 
 #if POZNAN_DBMP
-inline Void TComMP::getDBMPPredData(TComDataCU* pcCU, Int x, Int y, 
+Void TComMP::getDBMPPredData(TComDataCU* pcCU, Int x, Int y, 
 											Int &ref_frame0, Int &ref_frame0_idx, TComMv &mv0, Int ref_frame0_idx_2nd, TComMv mv0_2nd,
 											Int &ref_frame1, Int &ref_frame1_idx, TComMv &mv1, Int ref_frame1_idx_2nd, TComMv mv1_2nd)
@@ -1183,5 +1183,5 @@
 
 #if POZNAN_DBMP_CALC_PRED_DATA
-inline Void TComMP::xCalcDBMPPredData(UInt uiCnt, Int &ref_frame0_idx, TComMv &mv0, Int &ref_frame1_idx, TComMv &mv1)
+Void TComMP::xCalcDBMPPredData(UInt uiCnt, Int &ref_frame0_idx, TComMv &mv0, Int &ref_frame1_idx, TComMv &mv1)
 {	
 	if(uiCnt==0) return;
Index: branches/0.3-poznan-univ/source/Lib/TLibCommon/TComMP.h
===================================================================
--- branches/0.3-poznan-univ/source/Lib/TLibCommon/TComMP.h	(revision 41)
+++ branches/0.3-poznan-univ/source/Lib/TLibCommon/TComMP.h	(revision 45)
@@ -172,5 +172,5 @@
 #endif
 
-  inline Void getDBMPPredData(TComDataCU* pcCU, Int x, Int y, 
+  Void getDBMPPredData(TComDataCU* pcCU, Int x, Int y, 
 							  Int &ref_frame0, Int &ref_frame0_idx, TComMv &mv0, Int ref_frame0_idx_2nd, TComMv mv0_2nd,
 							  Int &ref_frame1, Int &ref_frame1_idx, TComMv &mv1, Int ref_frame1_idx_2nd, TComMv mv1_2nd);
@@ -185,5 +185,5 @@
   Int*			getTempL1MvY() {return m_piTempL1MvY;}
   
-  inline Void xCalcDBMPPredData(UInt uiCnt, Int &ref_frame0_idx, TComMv &mv0, Int &ref_frame1_idx, TComMv &mv1);
+  Void xCalcDBMPPredData(UInt uiCnt, Int &ref_frame0_idx, TComMv &mv0, Int &ref_frame1_idx, TComMv &mv1);
 #endif
 