Index: branches/0.3-nokia/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg
===================================================================
--- branches/0.3-nokia/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 50)
+++ branches/0.3-nokia/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 51)
@@ -15,7 +15,4 @@
 
 BitstreamFile             : stream.bit                             # bitstream file
-
-3DVFlexOrder 		:	0
-3DVCodingOrder 		:	T0D0D1D2T1T2
 
 
@@ -59,5 +56,6 @@
 TemporalLayerQPOffset_L6  : 6                                      # QP offset for temporal layer 6
 TemporalLayerQPOffset_L7  : 7                                      # QP offset for temporal layer 7
-
+FCO                       : 0                                      # flexible coding order (0:off, 1:on)
+CodingOrder               : T0D0D1T1                               # coding order 
 
 #========== encoder control /motion search ==========
@@ -117,7 +115,8 @@
 MVI                       : 1                                      # motion parameter inheritance
 
+#========== view synthesis optimization (VSO) ==========
+VSOConfig                 : [cx0 B(cc1) I(s0.5)][cx1 B(oo0) I(s0.5)] # VSO configuration string
+#VSOConfig                : [ox0 B(cc1) I(s0.5)][cx1 B(oo0) I(s0.5)] # VSO configuration string for FCO=1 and CodingOrder=T0D0D1T1
 
-#========== view synthesis optimization (VSO) ==========
-VSOConfig                 : [cx0 B(cc1) I(s0.5)][cx1 B(oo0) I(s0.5)]
-                                                                   # VSO configuration string
 
+
Index: branches/0.3-nokia/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg
===================================================================
--- branches/0.3-nokia/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 50)
+++ branches/0.3-nokia/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 51)
@@ -18,7 +18,4 @@
 
 BitstreamFile             : stream.bit                             # bitstream file
-
-3DVFlexOrder 		:	0
-3DVCodingOrder 		:	T0D0D1D2T1T2
 
 #========== general coding parameters ==========
@@ -61,5 +58,6 @@
 TemporalLayerQPOffset_L6  : 6                                      # QP offset for temporal layer 6
 TemporalLayerQPOffset_L7  : 7                                      # QP offset for temporal layer 7
-
+FCO                       : 0                                      # flexible coding order (0:off, 1:on) 
+CodingOrder               : T0D0D1D2T1T2                           # coding order   
 
 #========== encoder control /motion search ==========
@@ -113,5 +111,4 @@
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
 
-
 #========== depth coding tools ==========
 DMM                       : 1                                      # use depth intra modes (wedgelets)
@@ -119,7 +116,11 @@
 MVI                       : 1                                      # motion parameter inheritance
 
+#========== view synthesis optimization (VSO) ==========
+VSOConfig                 : [cx0 B(cc1) I(s0.5)][cx1 B(oo0) B(oo2) I(s0.5 s1.5)][cx2 B(cc1) I(s1.5)] # VSO configuration string
+#VSOConfig                : [ox0 B(cc1) I(s0.5)][cx1 B(oo0) B(oo2) I(s0.5 s1.5)][ox2 B(cc1) I(s1.5)] # VSO configuration string for FCO=1 and CodingOrder=T0D0D1D2T1T2
 
-#========== view synthesis optimization (VSO) ==========
-VSOConfig                 : [cx0 B(cc1) I(s0.5)][cx1 B(oo0) B(oo2) I(s0.5 s1.5)][cx2 B(cc1) I(s1.5)]
-                                                                   # VSO configuration string
 
+
+
+
+
Index: branches/0.3-nokia/cfg/encoder_mvd.cfg
===================================================================
--- branches/0.3-nokia/cfg/encoder_mvd.cfg	(revision 50)
+++ branches/0.3-nokia/cfg/encoder_mvd.cfg	(revision 51)
@@ -18,8 +18,4 @@
 BitstreamFile                 : BitStreamMV.bin
 
-3DVFlexOrder 		:	0
-3DVCodingOrder 		:	T0D0D1D2T1T2
-
-
 #====== General Coding Parameters ======
 NumberOfViews                 : 3           # Number of views to be coded
@@ -33,4 +29,7 @@
 OutputBitDepth                : 8           # Output bit-depth
 InternalBitDepth              : 10          # Internal bit-depth
+FCO                           : 0
+3DVCodingOrder                : T0D0D1D2T1T2
+
 
 #====== Camera Parameters ======
@@ -75,4 +74,7 @@
 VSOConfig                     : [cx0 B(cc1) I(s0.5)][cx1 B(oo0) B(oo2) I(s0.5 s1.5)][cx2 B(cc1) I(s1.5)]  #VSO Configuration (3-View) coding order 1 0 2 oder 1 2 0
 #VSOConfig                    : [cx0 B(cc1) I(s0.5)][cx1 B(oo0) I(s0.5)]                                  #VSO Configuration (2-View) coding order 1 0
+#VSOConfig                    : [ox0 B(cc1) I(s0.5)][cx1 B(oo0) B(oo2) I(s0.5 s1.5)][ox2 B(cc1) I(s1.5)]  #VSO Configuration (3-View) coding order 1 0 2 oder 1 2 0; FCO: 1
+#VSOConfig                    : [ox0 B(cc1) I(s0.5)][cx1 B(oo0) I(s0.5)]                                  #VSO Configuration (2-View) coding order 1 0; FCO 1
+
 
 #======== Quantization =============